/* $Id: crt0.S,v 1.4 1996/02/06 01:10:03 seb Exp $ */
/* Startup code for ARC BIOS executables

This file is part of Milo.

Milo is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

Milo is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Milo; see the file COPYING.  If not, write to
the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
Boston, MA 02111-1307, USA.  */
	
#include <asm/asm.h>
#include <asm/regdef.h>

/*
 * If this is acutally a bug or highly unusual behaviour for an ARC
 * BIOS is discussable.  All known to me load directly to the address
 * specified in the executable; just the SNI BIOS loads to address +
 * 8 bytes.
 *
 * Actually we should fix this using PIC code but we cannot do this yet
 * du to the binutils' lacking capabilities.
 */
#define SNI_ARC_BIOS_BUG

SPB_Base		=	0xa0001000
FirmwareVector_Offset	=	32

			.text

			.set	noreorder
			NESTED(_entry, 16, ra)
			subu	sp,16
			sw	ra,0(sp)

#ifdef SNI_ARC_BIOS_BUG
			/*
			 * First let's compute if we're really loaded to
			 * where we want ...
			 */
			bal	1f
			nop
1:			la	t0,1b
			beq	t0,ra,no_sni_arc_bios_bug
			subu	t0,ra,t0		# delay slot

			/*
			 * Ok, this seems to be the buggy SNI ARC BIOS that
			 * loads all data at a eight bytes to big address.
			 * Move down all initialized sections to the right
			 * place.  So far this are .test and .data
			 */

			la	t2,no_sni_arc_bios_bug	# .text
			addu	t1,t2,t0
			la	t3,_etext
1:			lb	v0,(t1)
			addiu	t1,1
			sb	v0,(t2)
			bne	t1,t3,1b
			addiu	t2,1			# delay slot

			la	t2,_sdata		# .data
			addu	t1,t2,t0
			la	t3,_edata
1:			lb	v0,(t1)
			addiu	t1,1
			sb	v0,(t2)
			bne	t1,t3,1b
			addiu	t2,1			# delay slot

			/*
			 * remember that this is the buggy SNI BIOS ...
			 */
			sw	t0,buggy_load_offset

			/*
			 * Here we should flush the caches but we're
			 * running uncached anyway ...
			 */

			/*
			 * These two nops will be overwritten
			 */
			nop
			nop
no_sni_arc_bios_bug:
#endif

			la	v0,SPB_Base
			lw	v0,FirmwareVector_Offset(v0)
			lui	t0,%hi(__FirmwareCallVector)
			jal	main
			sw	v0,%lo(__FirmwareCallVector)(t0)
			.set	reorder
			lw	ra,0(sp)
			.set	noreorder
			jr	ra
			addiu	sp,16
			END(_entry)

			.data
#ifdef SNI_ARC_BIOS_BUG
			/*
			 * This eight bytes will be overwritten while
			 * copying down.
			 */
_sdata:			.quad	0
buggy_load_offset:	.word	0
#endif

			.bss
			EXPORT(__FirmwareCallVector)
			PTR	0
